#include <algorithm>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <fstream>
#include <iostream>
#include <list>
#include <map>
#include <set>
#include <string>
#include <vector>
#include <queue>
#include <random>
#include <ctime>

#define ll long long
#define ld long double
#define F first
#define S second
#define upn(x, init, n) for (ll x = init; x <= n; ++x)
#define upiter(x, container) for (auto x = container.begin(); x != container.end(); ++x)
#define downn(x, init, n) for(ll x = init; x >= n; --x)
#define downiter(x, container) for (auto x = container.rbegin(); x != container.rend(); ++x)
#define pb push_back
#define mp make_pair
#define pll pair<ll, ll>
#define el '\n'
#define PI 3.1415926535897932384626433832795
#define eps 0.0000001
#define mod 1000000007

using namespace std;
ll n, k;
bool not_prime[100005];
vector<ll> prime;
ll cur_q, sum_q;
ld sumall_q, max_q, min_q = 1e9;
int x;

bool ask(ll d) {
    ++cur_q;
    return (x % d == 0);
}
ll dfs(int cx, int idx) {
    upn(i, idx, (ll) prime.size() - 1) {
        if (prime[i] * cx > 5000) {
            return cx;
        }
        if (ask(prime[i] * cx)) {
            return dfs(prime[i] * cx, i);
        }
    }
    return cx;
}
int main() {
    cin >> n >> k;
    srand( time(0) );
    upn(i, 2, 5000) {
        if (!not_prime[i]) {
            prime.pb(i);
            for (int j = i + i; j <= 5000; j += i) {
                not_prime[j] = true;
            }
        }
    }

    upn(j, 1, k) {
        upn(i, 1, n) {
            x = rand() % 5000 + 1;
            dfs(1, 0);
            sum_q += cur_q;
            cur_q = 0;
        }
        min_q = min(min_q, (ld) sum_q / n);
        max_q = max(max_q, (ld) sum_q / n);
        sumall_q += (ld) sum_q / n;
        sum_q = 0;
    }
    printf("[n = %lld][k = %lld] min_q %lf max_q %lf\naverage_q %lf\n", n, k, min_q, max_q, (sumall_q / k));
    cin >> n;
}
