#include <bits/stdc++.h>

using namespace std;

const int MAX = 5000;

bool notPrime[MAX + 1];
vector< int > prime;

int x[800];

bool get( int i, int d ) {
	cout << "? " << i+1 << " " << d << endl;
	cout.flush();
	string res;
	cin >> res;
	return ( res == "Yes" );
}

void get( int i ) {
	set< pair< int, int > > s;
	for( int j = 0; j < prime.size(); j ++ ) {
		s.insert( make_pair( prime[j], prime[j] ) );
	}
	int res = 1;
	while( s.size() ) {
		set< pair< int, int > >::iterator it = s.begin();
		int n = rand() % s.size();
		for( int i = 0; i < n; i ++ ) {
			it ++;
		}
		int y = it->first;
		int x = it->second;
		s.erase( it );
		if( res * x > MAX )
			continue;
		if( !get( i, y ) )
			continue;
		res *= x;
		y *= x;
		s.insert( make_pair( y, x ) );
	}
	x[i] = res;
}

void genPrime() {
	for( int i = 2; i <= MAX; i ++ ) {
		if( notPrime[i] )
			continue;
		for( long long j = i * 1LL * i; j <= MAX; j += i )
			notPrime[j] = true;
		prime.push_back( i );
	}
}

int main( void ) {
	srand( time( NULL ) );
	genPrime();

	int n;
	cin >> n;
	for( int i = 0; i < n; i ++ ) {
		get( i );
	}
	cout << "! ";
	for( int i = 0; i < n; i ++ ) {
		cout << x[i] << " ";
	}
	cout << endl;
	cout.flush();
	return 0;
}
